#include "mpi.h"
#include <stdio.h>

int main( argc, argv )
int argc;
char **argv;
{
  int rank, size, to, from, tag, count, i, ierr; 
  int src, dest; 
  int st_source, st_tag, st_count; 
  MPI_Status status;
  double data[100]; 
 
/* Prosty program wymiany 10 liczb calkowitych pomiedzy procesorem
   pierwszym (rzad 0) a ostatnim (rzad size-1). 
   Pozostale procesory nic nie robia. */

  MPI_Init( &argc, &argv );
  MPI_Comm_rank( MPI_COMM_WORLD, &rank ); 
  MPI_Comm_size( MPI_COMM_WORLD, &size ); 
  printf("Process %d of %d is alive\n",rank,size);
  dest = size - 1; 
  src = 0; 
  if (rank == src) {
    to     = dest; 
    count  = 10; 
    tag    = 2001; 
    for (i=0;i<10;i++)
      {
        data[i] = i+1; 
      }
    MPI_Send( data, count, MPI_DOUBLE_PRECISION, to, 
                           tag, MPI_COMM_WORLD );
  }else if (rank == dest) {
    tag   = MPI_ANY_TAG; 
    count = 10;
    from  = MPI_ANY_SOURCE; 
    MPI_Recv( data, count, MPI_DOUBLE_PRECISION, from, 
                          tag, MPI_COMM_WORLD, &status ); 
    printf("Processor %d received ",rank);
    for (i=0;i<10;i++) printf ("%10.5f",data[i]);
    printf("\n");
  }        
  MPI_Finalize(); 
  return 0;
}
